// Generated by CoffeeScript 1.7.0
(function() {
  var VoilaPlugin;

  module.exports = function(game, opts) {
    return new VoilaPlugin(game, opts);
  };

  module.exports.pluginInfo = {
    loadAfter: ['voxel-highlight', 'voxel-registry', 'voxel-registry', 'voxel-blockdata', 'voxel-keys'],
    clientOnly: true
  };

  VoilaPlugin = (function() {
    function VoilaPlugin(game, opts) {
      var _ref, _ref1, _ref2, _ref3;
      this.game = game;
      this.hl = (function() {
        var _ref1;
        if ((_ref = (_ref1 = this.game.plugins) != null ? _ref1.get('voxel-highlight') : void 0) != null) {
          return _ref;
        } else {
          throw new Error('voxel-voila requires voxel-highlight plugin');
        }
      }).call(this);
      this.registry = (function() {
        var _ref2;
        if ((_ref1 = (_ref2 = this.game.plugins) != null ? _ref2.get('voxel-registry') : void 0) != null) {
          return _ref1;
        } else {
          throw new Error('voxel-voila requires voxel-registry plugin');
        }
      }).call(this);
      if (this.registry.getItemDisplayName == null) {
        throw new Error('voxel-voila requires voxel-registry >=0.2.0 with getItemDisplayName');
      }
      this.blockdata = (_ref2 = this.game.plugins) != null ? _ref2.get('voxel-blockdata') : void 0;
      this.keys = (_ref3 = this.game.plugins) != null ? _ref3.get('voxel-keys') : void 0;
      this.createNode();
      this.enable();
    }

    VoilaPlugin.prototype.createNode = function() {
      var container;
      this.node = document.createElement('span');
      this.node.setAttribute('id', 'voxel-voila');
      this.node.setAttribute('style', 'background-image: linear-gradient(rgba(0,0,0,0.6) 0%, rgba(0,0,0,0.6) 100%); visibility: hidden; color: white; font-size: 18pt;');
      this.node.textContent = '';
      container = document.createElement('div');
      container.setAttribute('style', 'position: absolute; top: 0px; width: 100%; text-align: center;');
      container.appendChild(this.node);
      return document.body.appendChild(container);
    };

    VoilaPlugin.prototype.update = function(pos) {
      var bd, displayName, extra, id, name, x, y, z;
      this.lastPos = pos;
      if (this.lastPos == null) {
        this.clear();
        return;
      }
      id = this.game.getBlock(pos);
      name = this.registry.getBlockName(id);
      displayName = this.registry.getItemDisplayName(name);
      if (this.game.buttons.crouch) {
        if (this.blockdata != null) {
          x = pos[0], y = pos[1], z = pos[2];
          bd = this.blockdata.get(x, y, z);
          if (bd != null) {
            extra = "BD(" + x + "," + y + "," + y + "): " + (JSON.stringify(bd));
            window.status = extra;
            console.log(extra);
            extra = '+';
          } else {
            extra = '';
          }
        }
        return this.node.textContent = "" + displayName + " (" + name + "/" + id + ")" + extra;
      } else {
        return this.node.textContent = displayName;
      }
    };

    VoilaPlugin.prototype.clear = function() {
      this.lastPos = void 0;
      return this.node.textContent = '';
    };

    VoilaPlugin.prototype.enable = function() {
      this.node.style.visibility = '';
      this.hl.on('highlight', this.onHighlight = (function(_this) {
        return function(pos) {
          return _this.update(pos);
        };
      })(this));
      this.hl.on('remove', this.onRemove = (function(_this) {
        return function() {
          return _this.clear();
        };
      })(this));
      if (this.keys != null) {
        return this.keys.changed.on('crouch', this.onChanged = (function(_this) {
          return function() {
            return _this.update(_this.lastPos);
          };
        })(this));
      }
    };

    VoilaPlugin.prototype.disable = function() {
      this.hl.removeListener('highlight', this.onHighlight);
      this.hl.removeListener('remove', this.onRemove);
      if (this.keys != null) {
        this.keys.changed.removeListener('crouch', this.onChanged);
      }
      return this.node.style.visibility = 'hidden';
    };

    return VoilaPlugin;

  })();

}).call(this);
